
@ECHO OFF


set GERONIMO_HOME=C:\Program Files\IBM\WebSphere\AppServerCommunityEdition
set MAVEN_REPO=C:\Documents and Settings\jonas\.m2
set FUSE_VERSION=1.2.1-SNAPSHOT
set XBEAN_VERSION=fuse-2.5.0.0
set SPRING_VERSION=2.0-rc2




MKDIR "%GERONIMO_HOME%\repository\logicblaze\jars"
MKDIR "%GERONIMO_HOME%\repository\org.apache.xbean\jars"
MKDIR "%GERONIMO_HOME%\repository\springframework\jars"
MKDIR "%GERONIMO_HOME%\repository\retrotranslator\jars"
MKDIR "%GERONIMO_HOME%\repository\backport-util-concurrent\jars"
MKDIR "%GERONIMO_HOME%\fuse"
MKDIR "%GERONIMO_HOME%\bin\data"
MKDIR "%GERONIMO_HOME%\bin\data\deploy"
MKDIR "%GERONIMO_HOME%\bin\data\ldif"
MKDIR "%GERONIMO_HOME%\bin\data\liferayDB"
MKDIR "%GERONIMO_HOME%\bin\hotdeploy"


REM ######################################################################################################
REM remove xerces and xmlParser as it conflicts with the version FUSE uses and replace with a the 2.7.1 ver 
REM ######################################################################################################

DEL "%GERONIMO_HOME%\lib\endorsed\*.jar"
copy /Y  "%MAVEN_REPO%\repository\xerces\xercesImpl\2.7.1\xercesImpl-2.7.1.jar"  "%GERONIMO_HOME%\lib\endorsed"

REM ######################################################################################################
REM copy updated wasce config
REM ######################################################################################################

copy /Y  "src\main\resources\wasce\wasce_config\config\config.xml" "%GERONIMO_HOME%\var\config"

REM ######################################################################################################
REM copy data files
REM ######################################################################################################

copy /Y  "src\main\resources\apacheds\ldif\*.ldif"  "%GERONIMO_HOME%\bin\data\ldif"
copy /Y  "src\main\resources\liferay\database\hsql\liferayDB.*"  "%GERONIMO_HOME%\bin\data\liferayDB"


REM ######################################################################################################
REM copy dependencies
REM ######################################################################################################

copy /Y  "%MAVEN_REPO%\repository\retrotranslator\retrotranslator-transformer\1.0.3\retrotranslator-transformer-1.0.3.jar"  "%GERONIMO_HOME%\repository\retrotranslator\jars"
copy /Y  "%MAVEN_REPO%\repository\retrotranslator\retrotranslator-runtime\1.0.3\retrotranslator-runtime-1.0.3.jar"  "%GERONIMO_HOME%\repository\retrotranslator\jars"
copy /Y  "%MAVEN_REPO%\repository\backport-util-concurrent\backport-util-concurrent\2.1\backport-util-concurrent-2.1.jar"  "%GERONIMO_HOME%\repository\backport-util-concurrent\jars"
copy /Y  "target\fuse-%FUSE_VERSION%.jar"  "%GERONIMO_HOME%\repository\logicblaze\jars"
copy /Y  "%MAVEN_REPO%\repository\org\apache\xbean\xbean-spring\%XBEAN_VERSION%\xbean-spring-%XBEAN_VERSION%.jar"  "%GERONIMO_HOME%\repository\org.apache.xbean\jars"
copy /Y  "%MAVEN_REPO%\repository\org\springframework\spring\%SPRING_VERSION%\spring-%SPRING_VERSION%.jar"  "%GERONIMO_HOME%\repository\springframework\jars"



REM ######################################################################################################
REM copy WASCE configs for FUSE 
REM ######################################################################################################
copy /Y  "src\main\resources\wasce\fuse_config\ajax-demo\web.xml" "target\fuse-%FUSE_VERSION%\components\activemq\servicemix\portal\webapps\ajax-demo\WEB-INF"
rem copy /Y  "src\main\resources\wasce\fuse_config\grocery-demo\web.xml" "target\fuse-%FUSE_VERSION%\components\activemq\servicemix\portal\webapps\grocery-demo\WEB-INF"
copy /Y  "src\main\resources\wasce\fuse_config\fuselinks-portlet\view.jsp" "target\fuse-%FUSE_VERSION%\components\activemq\servicemix\portal\webapps\liferay\html\portlet\fuse\fuselinks"
copy /Y  "src\main\resources\wasce\fuse_config\liferay-config\web.xml" "target\fuse-%FUSE_VERSION%\components\activemq\servicemix\portal\webapps\liferay\WEB-INF"
copy /Y  "src\main\resources\wasce\fuse_config\liferay-config\portal.properties" "target\fuse-%FUSE_VERSION%\shared\classes"
copy /Y  "src\main\resources\wasce\fuse_config\xbean-config\activemq-xbean.xml" "target\fuse-%FUSE_VERSION%\components\activemq"
copy /Y  "src\main\resources\wasce\fuse_config\xbean-config\jmx-xbean.xml" "target\fuse-%FUSE_VERSION%\components\jmx"
copy /Y  "src\main\resources\wasce\fuse_config\xbean-config\jndi-xbean.xml" "target\fuse-%FUSE_VERSION%\components\jndi"
copy /Y  "src\main\resources\wasce\fuse_config\xbean-config\servicemix-xbean.xml" "target\fuse-%FUSE_VERSION%\components\activemq\servicemix"
copy /Y  "src\main\resources\wasce\fuse_config\xbean-config\jetty-xbean.xml" "target\fuse-%FUSE_VERSION%\components\activemq\servicemix\portal"


REM ######################################################################################################
REM Delete loanbroker as this require jdk1.5 and WASCE is only certified to run on 1.4
REM ######################################################################################################

rmdir  "target\fuse-%FUSE_VERSION%\components\activemq\servicemix\portal\webapps\loanbroker-client" /S /Q

DEL "target\fuse-%FUSE_VERSION%\hotdeploy\bank*.jar"
DEL "target\fuse-%FUSE_VERSION%\hotdeploy\creditagency*.jar"
DEL "target\fuse-%FUSE_VERSION%\hotdeploy\loanbroker*.jar"



REM ######################################################################################################
REM copy servicemix components
REM ######################################################################################################

copy /Y  "target\fuse-%FUSE_VERSION%\hotdeploy\*.*"  "%GERONIMO_HOME%\bin\hotdeploy"

REM ######################################################################################################
REM copy WASCE env settings
REM ######################################################################################################

copy /Y  "src\main\resources\wasce\wasce_config\bin\setenv.*" "%GERONIMO_HOME%\bin"

REM ######################################################################################################
REM copy FUSE to WASCE\fuse 
REM ######################################################################################################

xcopy  "target\fuse-%FUSE_VERSION%" "%GERONIMO_HOME%\fuse" /E


REM ######################################################################################################
REM deploy FUSE
REM ######################################################################################################  

rem "%GERONIMO_HOME%\bin\deploy.bat"  --user system --password manager deploy src/main/plan/plan.xml

