#!/bin/sh

# Set the environment variables
export GERONIMO_HOME=/home/joseph/logicblaze/IBM/WebSphere/AppServerCommunityEdition
export MAVEN_REPO=/root/.m2
export FUSE_VERSION=1.2.1-SNAPSHOT

mkdir "$GERONIMO_HOME/repository/logicblaze"
mkdir "$GERONIMO_HOME/repository/logicblaze/jars"
mkdir "$GERONIMO_HOME/repository/org.apache.xbean"
mkdir "$GERONIMO_HOME/repository/org.apache.xbean/jars"
mkdir "$GERONIMO_HOME/repository/springframework/"
mkdir "$GERONIMO_HOME/repository/springframework/jars"
mkdir "$GERONIMO_HOME/repository/retrotranslator"
mkdir "$GERONIMO_HOME/repository/retrotranslator/jars"
mkdir "$GERONIMO_HOME/repository/backport-util-concurrent"
mkdir "$GERONIMO_HOME/repository/backport-util-concurrent/jars"
mkdir "$GERONIMO_HOME/fuse"
mkdir "$GERONIMO_HOME/bin/data"
mkdir "$GERONIMO_HOME/bin/data/deploy"
mkdir "$GERONIMO_HOME/bin/data/ldif"
mkdir "$GERONIMO_HOME/bin/data/liferayDB"
mkdir "$GERONIMO_HOME/bin/hotdeploy"


# remove xerces and xmlParser as it conflicts with the version FUSE uses and replace with a the 2.7.1 ver 
rm -rf "$GERONIMO_HOME/lib/endorsed/*.jar"
cp "$MAVEN_REPO/repository/xerces/xercesImpl/2.7.1/xercesImpl-2.7.1.jar" "$GERONIMO_HOME/lib/endorsed"


# copy updated wasce config
cp "src/main/resources/wasce/wasce_config/config/config.xml" "$GERONIMO_HOME/var/config"


# copy data files
cp -R src/main/resources/apacheds/ldif/* "$GERONIMO_HOME/bin/data/ldif"
cp "src/main/resources/liferay/database/hsql/liferaydb.properties" "$GERONIMO_HOME/bin/data/liferayDB"
cp "src/main/resources/liferay/database/hsql/liferaydb.script" "$GERONIMO_HOME/bin/data/liferayDB"


# copy dependencies
cp "$MAVEN_REPO/repository/retrotranslator/retrotranslator-transformer/1.0.3/retrotranslator-transformer-1.0.3.jar" "$GERONIMO_HOME/repository/retrotranslator/jars"
cp "$MAVEN_REPO/repository/retrotranslator/retrotranslator-runtime/1.0.3/retrotranslator-runtime-1.0.3.jar"  "$GERONIMO_HOME/repository/retrotranslator/jars"
cp "$MAVEN_REPO/repository/backport-util-concurrent/backport-util-concurrent/2.1/backport-util-concurrent-2.1.jar"  "$GERONIMO_HOME/repository/backport-util-concurrent/jars"
cp "target/fuse-$FUSE_VERSION.jar" "$GERONIMO_HOME/repository/logicblaze/jars"
cp "$MAVEN_REPO/repository/org/apache/xbean/xbean-spring/fuse-2.5.0-SNAPSHOT/xbean-spring-fuse-2.5.0-SNAPSHOT.jar"  "$GERONIMO_HOME/repository/org.apache.xbean/jars"
cp "$MAVEN_REPO/repository/org/springframework/spring/2.0-rc2/spring-2.0-rc2.jar"  "$GERONIMO_HOME/repository/springframework/jars"


# copy WASCE configs for FUSE
cp "src/main/resources/wasce/fuse_config/ajax-demo/web.xml" "target/fuse-$FUSE_VERSION/components/activemq/servicemix/portal/webapps/ajax-demo/WEB-INF"
#cp "src/main/resources/wasce/fuse_config/grocery-demo/web.xml" "target/fuse-$FUSE_VERSION/components/activemq/servicemix/portal/webapps/grocery-demo/WEB-INF"
cp "src/main/resources/wasce/fuse_config/fuselinks-portlet/view.jsp" "target/fuse-$FUSE_VERSION/components/activemq/servicemix/portal/webapps/liferay/html/portlet/fuse/fuselinks"
cp "src/main/resources/wasce/fuse_config/liferay-config/web.xml" "target/fuse-$FUSE_VERSION/components/activemq/servicemix/portal/webapps/liferay/WEB-INF"
cp "src/main/resources/wasce/fuse_config/liferay-config/portal.properties" "target/fuse-$FUSE_VERSION/shared/classes"
cp "src/main/resources/wasce/fuse_config/xbean-config/activemq-xbean.xml" "target/fuse-$FUSE_VERSION/components/activemq"
cp "src/main/resources/wasce/fuse_config/xbean-config/jmx-xbean.xml" "target/fuse-$FUSE_VERSION/components/jmx"
cp "src/main/resources/wasce/fuse_config/xbean-config/jndi-xbean.xml" "target/fuse-$FUSE_VERSION/components/jndi"
cp "src/main/resources/wasce/fuse_config/xbean-config/servicemix-xbean.xml" "target/fuse-$FUSE_VERSION/components/activemq/servicemix"
cp "src/main/resources/wasce/fuse_config/xbean-config/jetty-xbean.xml" "target/fuse-$FUSE_VERSION/components/activemq/servicemix/portal"

# Delete loanbroker as this require jdk1.5 and WASCE is only certified to run on 1.4
rm -rf "target/fuse-$FUSE_VERSION/components/activemq/servicemix/portal/webapps/loanbroker-client"
rm -rf "target/fuse-$FUSE_VERSION/hotdeploy/bank*.jar"
rm -rf "target/fuse-$FUSE_VERSION/hotdeploy/creditagency*.jar"
rm -rf "target/fuse-$FUSE_VERSION/hotdeploy/loanbroker*.jar"

# copy servicemix components
cp -R target/fuse-$FUSE_VERSION/hotdeploy/* "$GERONIMO_HOME/bin/hotdeploy"

# copy WASCE env settings
cp -R src/main/resources/wasce/wasce_config/bin/* "$GERONIMO_HOME/bin"

# copy FUSE to WASCE/fuse 
cp -R target/fuse-$FUSE_VERSION/* "$GERONIMO_HOME/fuse"

# deploy FUSE
# "$GERONIMO_HOME/bin/deploy.bat"  --user system --password manager deploy src/main/plan/plan.xml



