/**
 *
 * Copyright 2005-2006 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.logicblaze.ldap;

import org.apache.directory.server.Service;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.core.io.Resource;

import java.io.File;
import java.io.IOException;

public class StartDirectoryService implements InitializingBean {

    private static final Log log = LogFactory.getLog(StartDirectoryService.class);

    private String xmlConfig;
    private Resource xmlConfigResource;

    public void afterPropertiesSet() throws Exception {
        if (xmlConfig == null && xmlConfigResource != null) {
            File xmlConfigFile = xmlConfigResource.getFile();
            xmlConfig = xmlConfigFile.getAbsolutePath();
        }

        Service service = new Service();
        service.init(null, new String[]{xmlConfig});
        service.start();
    }

    public static void main(String args[]){
        StartDirectoryService service = new StartDirectoryService();
        try {
            service.setXmlConfig("src/main/resources/apacheds.xml");
            service.start();

        } catch (Exception e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }

    public void start(){
        if (xmlConfig == null && xmlConfigResource != null) {
            File xmlConfigFile = null;
            try {
                xmlConfigFile = xmlConfigResource.getFile();
            } catch (IOException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }
            xmlConfig = xmlConfigFile.getAbsolutePath();
        }

        Service service = new Service();
        try {
            service.init(null, new String[]{xmlConfig});
        } catch (Exception e) {
            log.error("Error Starting Directory Service ", e);
        }
        service.start();
    }

    public String getXmlConfig() {
        return xmlConfig;
    }

    public void setXmlConfig(String xmlConfig) {
        this.xmlConfig = xmlConfig;
    }

    public Resource getXmlConfigResource() {
        return xmlConfigResource;
    }

    public void setXmlConfigResource(Resource xmlConfigResource) {
        this.xmlConfigResource = xmlConfigResource;
    }
}
